/*Macro setParms
Purpose: Transfer variable in SAS dataset to SAS macro variable
Input: 
	CovarianceReduced - SAS dataset with line and snp 1 to t;
outout:
	Va - sas macro variable;
	Ve - sas macro variable;
Strategy: NA
Example of usage: %setParms(CovarianceReduced);
Authors: Zhiwu Zhang (zz19@cornell.edu)
Date: Sep 25, 2008
*/

%macro setParms(CovarianceReduced);
data _temp;set &CovarianceReduced;drop CovParm;run;
proc iml;
start main;
*Load to matrix;
use _temp;
read all into A;
Va=A[1,1];
Ve=A[2,1];
call symput('Va',left(char(Va)));   
call symput('Ve',left(char(Ve))); 
finish;
run main;
quit;
%mend setParms;

