*=================================================================;
*Get average kinship for cluster;
*=================================================================;
*Input;
*     kinInd - kinship of individual;
*     cluster - cluster ID for individuals;
*Ouput;
*     kinCluster - average kkinship of cluster;
*Author: Zhiwu Zhang;
*Date: April 23, 2006;

%macro getAvgKin(kinInd,cluster,kinCluster);
proc iml;
start main;

print 'Macro getAvgKin is used';
*Step 1: Convert sas dataset to IML array;

*Import Kinship;
use &kinInd;
read all into KI;
nind = nrow(KI);

*Import cluster id;
use &cluster;
read all into c;
nC=ncol(unique(c));

*Step 2: Configration;
KC = j(nc,nc,0);*matrix of cluster kinship;
CC = j(nc,nc,0);*matrix of counter;

*print nInd;
*print nC;
*print C;

*Step 3: calculate average;
do i=1 to nInd;
	do j=i to nInd;
		if (c[i]<=c[j]) then
			do;
				indexI=c[i];
				indexJ=c[j];
			end;
		else
			do;
				indexI=c[j];
				indexJ=c[i];
			end;

		KC[indexI,indexJ]=KC[indexI,indexJ]+KI[i,j];
		CC[indexI,indexJ]=CC[indexI,indexJ]+1;
	end;
end;
*print KI;
*print KC;
*print CC;


do i=1 to nc;
	do j=i to nc;
			KC[i,j]=KC[i,j]/CC[i,j];
			KC[j,i]=KC[i,j];
	end;
end;
*print KC;


*Step 4: Output;
create &kinCluster from KC ;
append from KC;

print 'The program successfully ended. Congratulations!';

finish;
run main;
quit;
%mend;

